#pragma once


#define _CRTDBG_MAP_ALLOC // Ʒ  
#include <stdlib.h>
#include <crtdbg.h>

#include <windows.h>
#include <strsafe.h>

static LPVOID _GetLastErrorMsgW(wchar_t* lpszFunctionW, bool bShowMsgBox)
{

	DWORD eNum = ::GetLastError( );

	LPVOID lpSysMsg;
	::FormatMessageW(
					FORMAT_MESSAGE_ALLOCATE_BUFFER
					| FORMAT_MESSAGE_FROM_SYSTEM
					| FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					eNum,
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					(wchar_t*)&lpSysMsg,
					0, NULL);

	//// Trim the end of the line and terminate it with a null
	//wchar_t* p = (wchar_t*) lpSysMsg;
	//while( ( *p > 31 ) || ( *p == 9 ) )	++p;
	//do { *p-- = 0; } while( ( p >= lpSysMsg ) && ( ( *p == '.' ) || ( *p < 33 ) ) );

	LPVOID lpErrorMsgAllocBuf = (LPVOID)::LocalAlloc(LMEM_ZEROINIT, 
		(::lstrlenW((const wchar_t*) lpSysMsg) + ::lstrlenW((const wchar_t*) lpszFunctionW) + 80) * sizeof(wchar_t)); 
	
	::StringCchPrintfW((wchar_t*)lpErrorMsgAllocBuf, 
					::LocalSize(lpErrorMsgAllocBuf) / sizeof(wchar_t),
					L"GetLastError: code(%d), %s", 
					eNum, lpSysMsg); 

	::LocalFree(lpSysMsg);

	if (bShowMsgBox)
	{
		::MessageBoxW(::GetDesktopWindow()/*NULL*/, (const wchar_t*)lpErrorMsgAllocBuf, lpszFunctionW, MB_ICONSTOP); 
		//::MessageBoxW(::GetActiveWindow()/*NULL*/, (const wchar_t*)lpErrorMsgAllocBuf, lpszFunctionW, MB_ICONSTOP); 
		::LocalFree(lpErrorMsgAllocBuf);
		lpErrorMsgAllocBuf = NULL;
	}

	return lpErrorMsgAllocBuf;
}
static  int __cdecl _CrtRlsReportW(
		_In_opt_z_ const wchar_t * _FileName,
		_In_opt_z_ const wchar_t * _FunctionName,
        _In_ int _LineNumber,
        _In_opt_z_ const wchar_t * _Expression,
        _In_opt_z_ const wchar_t * _Format,
        ...) 
{
	wchar_t* pszLastMsgW = (wchar_t*) ::_GetLastErrorMsgW(NULL, false);

	#define _TEXT_BUFFSIZE	2048
	#define _TEMP_BUFFSIZE	1024
	wchar_t *pszTextW = new wchar_t[_TEXT_BUFFSIZE];
	wchar_t *pszTempW = new wchar_t[_TEMP_BUFFSIZE];
	pszTextW[0] = 0;

#ifdef _DEBUG
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"Debug Assertion Failed\r\n\r\nProgram: ");
#else
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"Release Verification Failed\r\n\r\nProgram: ");
#endif
	::GetModuleFileNameW(NULL, pszTempW, _TEMP_BUFFSIZE);
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszTempW);

	swprintf_s(pszTempW, _TEMP_BUFFSIZE, L"\r\n\r\nFile: %s", _FileName);
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszTempW);

	swprintf_s(pszTempW, _TEMP_BUFFSIZE, L"\r\n\r\nFunction: %s", _FunctionName);
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszTempW);

	swprintf_s(pszTempW, _TEMP_BUFFSIZE, L"\r\n\r\nLine: %d", _LineNumber);
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszTempW);
	
	if (_Expression != NULL)
	{
		swprintf_s(pszTempW, _TEMP_BUFFSIZE, L"\r\n\r\nExpression: %s", _Expression);
		wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszTempW);
	}

	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"\r\n\r\n");
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszLastMsgW);
	::LocalFree(pszLastMsgW);

	if (_Format != NULL) 
	{
		swprintf_s(pszTempW, _TEMP_BUFFSIZE, L"\r\nUserMessage: %s", _Format);
		wcscat_s(pszTextW, _TEXT_BUFFSIZE, pszTempW);
	}

#ifdef _DEBUG //GetActiveWindow ?
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"\r\n\r\nFor information on how your program can cause an assertion failure, see the Visual C++ documentation on asserts.");
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"\r\n\r\n(Press Retry to debug the application)");
	int nRet = ::MessageBoxW(::GetDesktopWindow(), pszTextW, L"Microsoft Visual C++ Debug Library", MB_ICONSTOP|MB_ABORTRETRYIGNORE|MB_DEFBUTTON1/*|MB_SETFOREGROUND*/|MB_TOPMOST);
#else
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"\r\n\r\nFor information on how your program can cause a verification failure, contact the developer, please.");
	wcscat_s(pszTextW, _TEXT_BUFFSIZE, L"\r\n\r\n(Press Retry to continue the application)");
	int nRet = ::MessageBoxW(::GetDesktopWindow(), pszTextW, L"Microsoft Visual C++ Release Library", MB_ICONSTOP|MB_ABORTRETRYIGNORE|MB_DEFBUTTON1/*|MB_SETFOREGROUND*/|MB_TOPMOST);
#endif

	delete [] pszTextW;
	delete [] pszTempW;
	
	if (nRet == IDABORT) exit(0);
	if (nRet == IDRETRY) return 1;
	return 0;
}

// Ʒ ο macro ۼϰ  
//  verify macroǿ (void)κ Ͽ if   ְ 
//    Ӹ ƴ϶   verify  ֵ ϱ ؼ̴.
//
// !! MFC Ϲ coding  ASSERT(expr); ϰ if(expr) Ѵ.
// ̴ expr ߺ  Ǳ     Ȥó expr  ٸ ϸ д.
//
//  macro ߿ 'B' پ ִ  release mode message box Ÿ  ִ.
//  macro ߿ 'M' پ ִ   message Բ   ִ.
// , message box  debug, release mode  ϰְ ϳ Ͻų  ְ,
// program, file, function, lineȣ, ǽ, GetLastError() message,  message Բ Ÿ  ִ.
//
//  : runtime library, api  Լ 'B' 
// framework, private classes, functions 'B' ̰ų 'M' ٿ  .
// library ؿ release mode  message box ϴ   ʴ.
//
// !!!
// program   assert, verify  ϸ
// window ̹ ıǾ 
// message â  ϰ memory leak ߻Ų.
//   assert, verify ʿ Ȳ̸鼭    ȴٸ
// , assert, verify   ̸ Ȯ ϴ Ǵܹ ʿϴ.
//
//
// ۵ 帧
// _CrtRlsReportW abort button  exit Ѵ.
// retry button  ؼ  code,  _CrtDbgBreak    0 ǰ
// ignore button  _CrtDbgBreak  ʰ  1 ȴ.
// _CrtDbgReportW ϰ ϵ ۼϿ Ӹƴ϶,    ϵ ۼϿ.
// (_CrtDbgBreak(), 0)̶  _CrtDbgBreak void Լ̱  return  Ƿ ִ ̴.
// _CrtDbgBreak retry button F10(ν  ), ignore button F5( ) شȴ.
//  ϸ, _CrtDbgBreak ʿ䰡  δ.
// Դٰ debug modḛ, ' ʰ '  , retry button  ع.
// ׷, break  ġ ڵ ãư ؼ _CrtDbgBreak ʿϴ.
// release mode  _CrtDbgBreak (void)0̱  Ű澵 ʿ䰡 .
//
#ifndef _CRT_WIDE
#define __CRT_WIDE(_String) L ## _String
#define _CRT_WIDE(_String) __CRT_WIDE(_String)
#endif

#define __DEBUG_RELEASE(expr, msg) \
			((expr) \
			||  (1 != _CrtRlsReportW(_CRT_WIDE(__FILE__), _CRT_WIDE(__FUNCTION__), __LINE__, _CRT_WIDE(#expr), msg)) \
			|| (_CrtDbgBreak(), 0))
#ifdef _DEBUG
#define __ASSERTM(e, m)			(__DEBUG_RELEASE((e), m))
#define __FVERIFYM(e, m)			(__DEBUG_RELEASE((e), m))
#define __TVERIFYM(e, m)			(!__DEBUG_RELEASE(!(e), m))
#define __FVERIFYMB(e, m)		(__DEBUG_RELEASE((e), m))
#define __TVERIFYMB(e, m)		(!__DEBUG_RELEASE(!(e), m))
#else
#define __ASSERTM(e, m)			(/*(void)*/0)
#define __FVERIFYM(e, m)			(e)	// no message box
#define __TVERIFYM(e, m)			(e)	// no message box
#define __FVERIFYMB(e, m)		(__DEBUG_RELEASE((e), m)) // message box appears
#define __TVERIFYMB(e, m)		(!__DEBUG_RELEASE(!(e), m))	// messabe box
#endif
#define __ASSERT(e)					__ASSERTM(e, NULL)
#define __FVERIFY(e)				__FVERIFYM(e, NULL)
#define __TVERIFY(e)				__TVERIFYM(e, NULL)
#define __FVERIFYB(e)				__FVERIFYMB(e, NULL)
#define __TVERIFYB(e)				__TVERIFYMB(e, NULL)


// if  ǽĿ !, <, >, =  ߸  츦 assertѴ.
// if  ǽĿ Թ =  ϴ (ϴ coding)  Ʋ  assertȴ. 
#ifdef _DEBUG
static bool _CorrExpr(wchar_t* _Expr)
{
	//::SetLastError(ERROR_NOT_SUPPORTED);
	//L"!", L"!>", L"!<", L"!=", L">", L">=", L"<",  L"<=", L"==", L""};
	int l = wcslen(_Expr);
	wchar_t prev = L'\0';
	for (int i=0; i<l; i++)
	{
		switch (_Expr[i])
		{
			case L'!' :
				if (prev != L'\0') return false;
				prev = L'!';
				break;
			case L'>' :
				if (prev != L'\0' && prev != L'!') return false;
				if (prev == L'\0') prev = L'>';
				else prev = L'\0';
				break;
			case L'<' :
				if (prev != L'\0' && prev != L'!') return false;
				if (prev == L'\0') prev = L'<';
				else prev = L'\0';
				break;
			case L'=' :
				if (prev != L'\0' && prev != L'!' && prev != L'>' && prev != L'<' && prev != L'=') return false;
				if (prev == L'\0') prev = L'=';
				else prev = L'\0';
				break;
			default:
				if (prev == L'=') return false;
				prev = L'\0';
				break;
		}
	}

	return true;
}

#define if(e)		if (	_CorrExpr(_CRT_WIDE(#e)) ? (!!(e)) : \
							(1 != _CrtRlsReportW(_CRT_WIDE(__FILE__), _CRT_WIDE(__FUNCTION__), __LINE__, _CRT_WIDE(#e), L"Invalid Criteria")) \
							|| (_CrtDbgBreak(), 0))
#define while(e)	while (_CorrExpr(_CRT_WIDE(#e)) ? (!!(e)) : \
							(1 != _CrtRlsReportW(_CRT_WIDE(__FILE__), _CRT_WIDE(__FUNCTION__), __LINE__, _CRT_WIDE(#e), L"Invalid Criteria")) \
							|| (_CrtDbgBreak(), 0))
#endif

/*
 <޸  Ȯ >
 The following macros set and clear, respectively, given bits
 of the C runtime library debug flag, as specified by a bitmask.
 1.   free    Ҵ   .
		_CrtMemDumpAllObjectsSince( NULL );
 2.   Ҵ 
		char *p;
		_CrtMemState s1, s2, s3;
		_CrtMemCheckpoint( &s1 );
		p = malloc(10);
		_CrtMemCheckpoint( &s2 );
		if ( _CrtMemDifference( &s3, &s1, &s2 ) ) _CrtMemDumpStatistics( &s3 );
 3. free    ջ Ȯ
		_CrtCheckMemory( );
		or    :
		SET_CRT_DEBUG_FIELD(_CRTDBG_CHECK_CRT_DF);
 4. _malloc_dbg( 40, _CLIENT_BLOCK, __FILE__, __LINE__ ); ϶
		_CLIENT_BLOCK  ϸ dbgheap.c assertȴ. 
		_NORMAL_BLOCK  .
 5. free   check
		_CrtDumpMemoryLeaks();
		or    :
		SET_CRT_DEBUG_FIELD(_CRTDBG_LEAK_CHECK_DF);
 6.	_CRTDBG_MAP_ALLOC ǵǸ
		 ޸𸮸 Ҵ  ã  ֽϴ
		,  (_Debug.h)   ǵǾ . 
		׸,  Ʒ include   յ  ٲ ȵȴٰ
		MSDN  ִ.
 7. α׷ ׻  ġ Ǵ 쿡
		 ġ _CrtDumpMemoryLeaks  ȣ  ֽϴ.
		α׷  ġ   ִ 쿡
		  ִ  ġ _CrtDumpMemoryLeaks ȣϴ 
		α׷  κп  ȣ   ֽϴ.

		   : 
	SET_CRT_DEBUG_FIELD(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);

		̶, _CRTDBG_CHECK_CRT_DF ϸ
		stdenvp.c leak ߰ߵ  ִ. ̴ ߸  ƴϴ Ѵ.
		 : http://social.msdn.microsoft.com/Forums/en-US/vcgeneral/thread/58cfabb5-3695-4cb4-98d7-a2721c6e35e4/#448c88fc-7463-49c8-8c20-3382a71d8d40
*/
#ifdef   _DEBUG
#define  SET_CRT_DEBUG_FIELD(a) \
            _CrtSetDbgFlag((a) | _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#define  CLEAR_CRT_DEBUG_FIELD(a) \
            _CrtSetDbgFlag(~(a) & _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#else
#define  SET_CRT_DEBUG_FIELD(a)   ((void) 0)
#define  CLEAR_CRT_DEBUG_FIELD(a) ((void) 0)
#endif

/*
	MFC
	<new> Ű  ´ Ʒ .

		<afx.h> Ʒ   ǵǾ ִ.
		#define THIS_FILE          __FILE__
		#define DEBUG_NEW new(THIS_FILE, __LINE__)

		׸,  (*.cpp) տ  ڵ尡 ߰Ǿ ִ.
		#ifdef _DEBUG
		#define new DEBUG_NEW
		#endif

	<malloc(szie)>Լ debug mode 
	malloc_dbg(size, _NORMAL_BLOCK, __FILE__, __LINE__ ) Ǯ ȴ.
	
*/
